=== debian/changelog ===
sundials (3.1.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Set OMPI_MCA_rmaps_base_oversubscribe=1 when running the testsuite, this
    prevents FTBFS when there are not enough CPUs. Thanks to Graham Inggs for
    the hint. (Closes: #910352)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 15 Nov 2018 12:35:10 +0100

sundials (3.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release: 3.1.1
  * Add lintian overrides for differing sonames
  * SONAME bumps for all the libraries
  * New sub-libraries:
    - libsundials-sunlinsol1
    - libsundials-sunmatrix1
  * Removed libsundials-doc; examples are now shipped in libsundials-dev

 -- Dima Kogan <dkogan@debian.org>  Sat, 16 Jun 2018 01:05:45 -0700
